/*  ====================================================================  *
 *				Mined.h					  *
 *  ====================================================================  */

#ifndef minedH
#define minedH

#ifdef __MSDOS__
#undef unix	/* needed for djgcc? */
#define msdos
#define pc
# ifndef __TURBOC__
# define __GCC__
# undef msdos	/* in this queer case, a more specific distinction */
# define unix	/* has to be made everywhere according to the 'pc' flag */
# endif
#endif

#ifdef msdos
/* With Turbo-C, compile with memory model >= Compact */
/* #define conio doesn't work with current combined positioning/output method */
extern far * getenv ();
extern far * getcwd ();
extern void setdisk ();
#include <string.h>
#include <io.h>
#  include <stdio.h>
#  undef putchar
#  include <fcntl.h>
#  define FUNcmd	'\000'
extern void sleep ();
extern void delay ();
extern void exit ();
#endif

#ifdef vms
#  include <unixio.h>
#  include <file.h>	/* for the O_... attributes to open () */
#  include <unixlib.h>
#  undef putchar
#  undef FALSE
#  undef TRUE
#  define CURSES
#  define FUNcmd	'\000'
#endif

#ifdef SYSV
#define sysV
#endif

#ifdef SYS5
#define sysV
#endif

#ifdef TERMIO
#ifndef sysV
# define sysV
#endif
#endif

#ifdef sysV
#ifndef unix
# define unix
#endif
/*# define TERMIO*/
#endif

#ifdef unix

/*#include <stdlib.h> */
#  include <stdio.h>
#  include <string.h>
/*#include <strings.h> ? */
#  include <fcntl.h>
#  include <unistd.h>
#  undef putchar
#  undef NULL
#  undef EOF
#  define FUNcmd	'\000'

#  ifdef sysV
   extern char * getcwd ();
#  else
   extern char * getwd ();
#  define getcwd(dirbuf, buflen)	getwd (dirbuf)
#  endif

extern void exit ();
extern char * getenv ();
/*extern int printf ();*/

/* already declared in <unistd.h>
#ifdef __STDC__
extern pid_t vfork ();
#else
#ifdef _CLASSIC_ID_TYPES
#define is_this_a_HP_special
extern int vfork();
#else
extern pid_t vfork ();
#endif
#endif
*/

#ifdef __GCC__
extern int wait ();
#else
extern pid_t wait ();
#endif
extern int select ();
extern unsigned int sleep ();
#ifndef __linux__
extern unsigned int usleep ();
#endif
#endif /* unix */


typedef unsigned char character;
/*typedef unsigned int character;*/

/*------------------------------------------------------------------------*/

extern void raw_mode ();
extern void clear_screen ();
extern void clear_eol ();
extern void scroll_forward ();
extern void scroll_reverse ();
extern void add_line (/* y */);
extern void delete_line (/* y */);
extern void move_cursor (/* x, y */);
extern void reverse_on ();
extern void reverse_off ();
extern void altcset_on ();
extern void altcset_off ();
extern void start_extracset ();
extern void end_extracset ();
extern void dimon ();
extern void dimoff ();
extern void ctrldisp_on ();
extern void ctrldisp_off ();
extern void menudisp_on ();
extern void menudisp_off ();
extern void diagdisp_on ();
extern void diagdisp_off ();
extern void start_screen_mode ();
extern void end_screen_mode ();
extern void get_term ();
extern void getwinsize ();

#ifdef msdos
extern void set_video_lines ();
extern void set_textmode_height ();
extern void switch_textmode_height ();
extern void set_grafmode_height ();
extern void set_fontbank ();
extern void set_screen_mode ();
extern void resize_screen ();
#endif

extern int inputreadyafter ();
extern int readchar ();
extern int _readchar ();
extern int __readchar ();

extern int find_y ();
extern int find_y_w_o_RD ();
extern int scratch_file ();
extern void suspendmyself ();
extern void catch_signals ();
extern int char_ready_within ();
extern int get_number ();
extern void display ();
extern void reset ();
extern void move_y ();
extern void move_to ();
extern void set_cursor_xy ();
extern void put_line ();
extern void move_address ();
extern void move_address_w_o_RD ();
extern int length_of ();
extern int char_count ();
extern int insert ();
extern void copy_string ();
extern int get_file ();
extern int get_line ();
extern void bad_write ();
extern void file_status ();
extern int find_x ();
extern void RDwin ();
extern void RD_y ();
extern void panicio ();
extern int panicwrite ();
extern void edit_nth_file ();
extern void set_font_height ();

extern unsigned int compose ();
extern character grave ();
extern character circumflex ();
extern character acute ();
extern character diaeresis ();
extern character tilde ();
extern character angstrom ();

/* aux: */
extern void delete_yank_file ();
extern void rd_bottom_line ();
extern void clear_wholeline ();
extern void clear_lastline ();
extern void (* keyproc) ();
extern void catch_interrupt ();
extern int make_number ();

/* from system: */
extern int write ();
extern int read ();
extern int access ();
/*extern int open ();*/
extern int close ();
extern int creat ();
extern int chdir ();
extern int system ();
extern int isatty ();
#ifndef strcmp
extern int strcmp ();
#endif

/*------------------------------------------------------------------------*/

/*
 * Convert cnt to nearest tab position
 */
#define tab(cnt)		(((cnt) + 8) & ~07)
#define is_tab(c)		((c) == '\t')
/*
 * Word definitions
 */
#define white_space(c)	((c) == ' ' || (c) == '\t')
#define alpha(c)	((c) != ' ' && (c) != '\t' && (c) != '\n')

/* Set cursor at coordinates x, y */
#define set_cursor(nx, ny)	move_cursor(nx, ny)

/* Screen size and display definitions. Coordinates start at 0, 0 */
#ifdef pc
#  define maxYMAX		64
#  define maxXMAX		132
#else
#  define maxYMAX		126	/* 73 */
#  define maxXMAX		279	/* 163 */
#endif

extern short YMAX;
extern short XMAX;
extern short MENU;
#define SCREENMAX	(YMAX - 1)	/* last line displayed (first is 0) */
#define XBREAK		(XMAX)		/* Shift line display at this column */
#define SHIFT_SIZE	(tab (XMAX / 4 + 1))	/* Number of chars to shift */
#define maxLINE_LEN	(maxXMAX + 1)	/* max screen line length */
#define screen_BUFL	((((maxXMAX * maxYMAX) >> 10) + 1) << 10)
					/* Size of I/O buffering */

#define MAX_CHARS	1024		/* max chars on one line of text */
		/* LINE_START must be rounded up to the lowest SHIFT_SIZE */
#define LINE_START	(((-MAX_CHARS - 1) / SHIFT_SIZE) * SHIFT_SIZE \
  				   - SHIFT_SIZE)
#define LINE_END	(MAX_CHARS * 8)	/* Must be larger than highest 
					x-coordinate for line; MAX_CHARS + 1
					is not sufficient due to TABs */

#define BLOCK_SIZE	1024

/* Return values of functions */
#define ERRORS		-1
#define NO_LINE		(ERRORS - 1)	/* Must be < 0 */
#define FINE	 	(ERRORS + 1)
#define NO_INPUT	(ERRORS + 2)

#define STD_IN		0		/* Input file # */
#define STD_OUT	 	1		/* Terminal output file # */
#define STD_ERR		2

#define REPORT	1		/* Report change of lines on # lines */

#ifndef pc
# define O_BINARY 0
#endif

/*
 * mouse button selection
 */
typedef enum {
	leftbutton,
	middlebutton,
	rightbutton,
	releasebutton
} mousebutton;

#define shift_button	4
#define meta_button	8
#define control_button	16

/*
 * Common enum type for all flags used in mined.
 */
typedef enum {
/* General flags */
  False,
  True,
  OFF,
  ON,
/* yank_status and other */
  NOT_VALID,
  VALID,

/* Expression flags */
  FORWARD,
  REVERSE,

/* Yank flags */
  SMALLER,
  BIGGER,
  SAME,
/*  EMPTY, */
  NO_DELETE,
  DELETE,
  READ,
  WRITE
} FLAG;

/*
 * The Line structure. Each line entry contains a pointer to the next line,
 * a pointer to the previous line, a pointer to the text and an unsigned char
 * telling at which offset of the line printing should start (usually 0).
 */
struct Line {
  struct Line * next;
  struct Line * prev;
  char * text;
  unsigned char shift_count;
};

typedef struct Line LINE;

/* Dummy line indicator */
#define DUMMY		0x80
#define DUMMY_MASK	0x7F

/* Expression definitions */
#define NO_MATCH	0
#define MATCH		1
#define REG_ERROR	2

#define BEGIN_LINE	(2 * REG_ERROR)
#define END_LINE	(2 * BEGIN_LINE)

/*
 * For casting functions with int/void results
 */
typedef void (* voidfunc) ();
typedef character (* charfunc) ();
typedef int (* intfunc) ();

/*
 * Determine multi-character prefix bytes (Chinese)
 */
#define multichar(c)	((character) c > '\177')
extern int inChinese ();
extern void advance_utf8 ();
extern void advance_char ();
extern void advance_char_col ();
extern void precede_char ();
extern int UTF_len ();

/*
 * The regex structure. Status can be any of 0, BEGIN_LINE or REG_ERROR. In
 * the last case, the result.err_mess field is assigned. Start_ptr and end_ptr
 * point to the match found. For more details see the documentation file.
 */
struct regex {
  union {
  	char * err_mess;
  	int * expression;
  } result;
  char status;
  char * start_ptr;
  char * end_ptr;
};

typedef struct regex REGEX;

/* NULL definitions */
#define NIL_PTR		((char *) 0)
#define NIL_LINE	((LINE *) 0)
#define NIL_REG		((REGEX *) 0)
#define NIL_INT		((int *) 0)

/*
 * Forward declarations
 */
extern int total_lines;		/* Number of lines in file */
extern long total_chars;	/* Number of characters in file */
extern LINE * header;		/* Head of line list */
extern LINE * tail;		/* Last line in line list */
extern LINE * top_line;		/* First line of screen */
extern LINE * bot_line;		/* Last line of screen */
extern LINE * cur_line;		/* Current line in use */
extern char * cur_text;		/* Pointer to char on current line in use */
extern int last_y;		/* Last y of screen, usually SCREENMAX */
extern int line_number;		/* current line # determined by file_status */
extern int lines_per_page;	/* assumption for file_status */

extern int x, y;		/* x, y coordinates on screen */
extern FLAG modified;		/* Set when file is modified */
extern FLAG viewonly;		/* Set when view only mode is selected */
extern FLAG restricted;		/* Set when restricted mode is selected */
extern FLAG quit;		/* Set when quit character is typed */
extern FLAG intr_char;		/* Set when intr character is typed */
extern FLAG winchg;		/* Set when the window size changes */
extern FLAG waitingforinput;	/* Set while waiting for the next command key */
extern FLAG isscreenmode;	/* Set when screen mode is on */
extern unsigned int out_count;	/* Index in output buffer */
extern char text_buffer [MAX_CHARS];	/* Buffer for modifying text */
extern int input_fd;		/* File descriptors for terminal dialog */
extern int output_fd;
extern unsigned int fprot;		/* To be used for file creatings */
extern unsigned int bufprot;		/* To be used for paste buffer file */

#ifdef unix
extern char * window_string_code;
extern char window_string [];	/* to set text in window headline and icon */
#endif

extern char yank_file [];	/* Temp. file for buffer */
extern char yankie_file [];	/* Temp. file for inter-window buffer */
extern char panic_file [];	/* file for panic-write-back */
extern FLAG yank_status;	/* Status of yank_file */
extern long chars_saved;	/* # of chars saved in buffer */

extern int escape_delay;	/* wait to detect escape sequence */
extern int hop_flag;		/* set to 2 by HOP key function */
extern int JUSlevel;		/* keep justified while typing? */
extern int JUSmode;		/* 1: paragraphs end at empty line */
extern FLAG insert_mode;	/* insert or overwrite */
extern FLAG append_flag;	/* Set when buffer should be appended to */
extern character erase_char;	/* effective (configured) char for erase left */
extern character control_prefix;	/* ^V/^P character to prefix control chars */
extern FLAG Chinese;		/* set if two-byte characters are enabled */
extern FLAG utf8_screen;	/* screen driven in UTF-8 mode ? */
extern FLAG utf8_input;		/* keyboard input in UTF-8 mode ? */
extern FLAG utf8_text;		/* text in UTF-8 representation ? */
extern FLAG last_char_latin1;	/* was accented character composed? */
extern FLAG loading;		/* Loading a file? Init True for error handling */
extern char screen [];		/* I/O buffer for "writes" and "reads" */
extern FLAG wordnonblank;	/* handle all non-blank sequences as words */
extern FLAG proportional;	/* Enable support for proportional fonts? */
extern FLAG transdeutsch;	/* Transform input {->, ..., ~-> ? */
extern FLAG translate_output;	/* Transform output diacritics to strings */
extern char * transout;		/* Output transformation table */
extern char * dimansi;		/* special character dimming ANSI sequence */
extern char * ctrlansi;		/* control character display ANSI sequence */
extern char * uniansi;		/* Unicode character display ANSI sequence */
extern char * menuansi;		/* menu line ANSI sequence */
extern char * diagansi;		/* dialog (bottom status) line ANSI sequence */
extern int translen;		/* length of " */
extern FLAG controlQS;		/* must respect ^Q/^S handshake ? */
extern int display_delay;	/* delay between display lines */
extern char TABchar;		/* Char to be shown in place of tab chars */
extern char TABchar0;		/* Char to be shown at start of tab chars */
extern char TABchar2;		/* Char to be shown at end of tab chars */
extern char TABcharmid;		/* Char to be shown in middle of tab chars */
extern char SHIFT_BEG;		/* Char indicating that line continues left */
extern char RET_MARK;		/* Char indicating end of line */
extern char PARA_MARK;		/* Char indicating end of paragraph */
extern char RET_BLANK;		/* Char to fill the end of line with */
extern char RET_BLANK2;		/* Char to fill last position of line with */
extern char * UTF_TAB;		/* Char to be shown in place of tab chars */
extern char * UTF_TAB0;		/* Char to be shown at start of tab chars */
extern char * UTF_TAB2;		/* Char to be shown at end of tab chars */
extern char * UTF_TABmid;	/* Char to be shown in middle of tab chars */
extern char * UTF_RET;		/* Char indicating end of line */
extern char * UTF_PARA;		/* Char indicating end of paragraph */
extern char * UTF_RETblank;	/* Char to fill the end of line with */
extern char * UTF_RETblank2;	/* Char to fill last position of line with */
extern char UNI_MARK;		/* char to be shown in place of Unicode char */
extern char TABdefault;		/* Char displayed instead of TABs */
extern char RETdefault;		/* Char displayed to indicate line-end */
extern char PARAdefault;	/* Char displayed to indicate end of paragraph */
extern FLAG paradisp;		/* Shall paragraph end be distinguished? */
extern char SHIFT_MARK;		/* Char indicating that line continues */
extern character ring;		/* Ring accent character */
extern FLAG rpipe;		/* Set if file should be read from stdin */
extern FLAG stat_visible;	/* Set if status_line is visible */
extern FLAG top_line_scrolled;	/* was menu line scrolled away? */
extern FLAG always_disp_code;	/* Permanent char code display on status line? */
extern FLAG use_extracset;	/* Set if MINEDMARK enables graph. mark mode */

extern void (* key_map [256]) ();
extern void (* ws_key_map [32]) ();
extern void (* pc_key_map [256]) ();

extern FLAG can_scroll_reverse, can_add_line, can_delete_line, can_clear_eol;
extern FLAG page_scroll;	/* use scroll for page up/down */
extern FLAG page_stay;		/* stay at edge of page after page up/down */
extern FLAG cansuspendmyself;
extern void reset_get_line ();
extern void show_get_l_errors ();
extern char * serror ();
extern char * serrorof ();
extern int geterrno ();

extern void set_modified ();

extern LINE * proceed ();
extern LINE * match ();
extern LINE * line_insert ();
extern char * num_out ();
extern int get_digits ();
extern char * basename ();
extern character promptyn ();
extern void display_scrollbar ();
extern FLAG checkoverwrite ();
extern void delete_file ();
extern char * unnull ();
extern void search_for ();
extern void viewonlyerr ();
extern void restrictederr ();
extern void set_up ();

#define putchar(c)	__putchar (c)
extern void put_char ();
extern void __putchar (); /* do not use _putchar! it may conflict with curses */
extern void pututf8 ();
extern int writechar ();
extern int writestring ();
extern int flush_buffer ();
extern void putstring ();
extern void flush ();
extern void panic ();
extern char * alloc ();
extern void free_space ();
extern LINE * alloc_header ();
extern void free_header ();

/* menu handling */

extern void MINMEN (), QUICKMEN ();
extern mousebutton mouse_button, mouse_lastbutton;
extern int mouse_shift;
extern int mouse_xpos, mouse_ypos, mouse_lastxpos, mouse_lastypos;
extern FLAG report_release;
extern void clear_menus ();
extern void displaymenuline ();
extern void displayflags ();
extern void toggleappend ();
extern FLAG scrollbar;

/* The main editing functions */

extern void MOUSEescape (), DIRECTcrttool (), DIRECTxterm ();
extern void MUP (), MDN (), MLF (), MRT (), MNW (), MPW ();
extern void BSEN (), ESEN (), SCORR ();
extern void SD (), SU (), PD (), PU (), BFILE (), EFILE ();
extern void BLINE (), ELINE (), HIGH (), LOW ();
extern void SNL (), LIB (), DPC (), DCC (), DLN (), DNW (), DPW ();
extern void S0 (), DCC0 (), DPC0 ();
extern void CTRl (), DLINE (), TOGINS (), ctrlQ (), ctrlK (), ctrlO ();
extern void JUS (), JUSandreturn ();
extern void QUED (), WT (), WTU (), SAVPOS (), EDIT (), NN ();
extern void RD (), RDwin (), I ();
extern void EXED (), VIEW (), GOTO (), GOMA (), REPT (), HELP ();
extern void SFW (), SRV (), RS (), LR (), GR (), REPL ();
extern void MARK (), YA (), DT (), PT (), WB (), INSFILE ();
extern void HOP (), CANCEL (), ESCAPE (), BAD (), FUNKEY ();
extern void CHDI (), PBUF (), CMD (), SH (), SUSP ();
extern void LNCI (), LNSW ();
extern void UML (), LOWCAP (), TOGGO ();
extern void SIDFW (), SIDRV (), HTML (), MARKER (), GOMARKER ();
extern void EDITmode (), VIEWmode ();
extern void NXTFILE (), PRVFILE (), NTHFILE (), EXFILE (), EXMINED ();
extern void ADJLM (), ADJFLM (), ADJNLM (), ADJRM (), ADJPAGELEN ();
extern void FS (), FSTAT (), HELPF (), HELPS (), HELPC (), HELPA ();
extern void display_code (), display_the_code (), changeuni (), changehex (), changeoct (), changedec ();
extern void screensmaller (), screenbigger (), screenlesslines (), screenmorelines ();

extern void MARKn (), GOMAn (), Markn (), Pushmark ();
extern void S (), RD_y ();
extern void goproz ();

/*
 * String functions
 */
#define streq(s1, s2)		(strcmp (s1, s2) == 0)
#define strisprefix(s1, s2)	(strncmp (s2, s1, strlen (s1)) == 0)

/*
 * Empty output buffer
 */
#define clear_buffer()		(out_count = 0)

/*
 * Ring bell on terminal
 */
#ifdef msdos
extern void ring_bell ();
#else
#define ring_bell()		putchar ('\07')
#endif

/*
 * Print line on terminal at offset 0 and clear tail of line
 */
#define line_print(line)	put_line (line, 0, True, False)

/*
 * Functions handling status_line. ON means in reverse video.
 */
extern int bottom_line ();
#define status_msg(str)		status_line (str, NIL_PTR)
#define status_line(str1, str2)		\
	(void) bottom_line (ON, (str1), (str2), NIL_PTR, False, "")
#define status_beg(str)			\
	(void) bottom_line (ON, (str), NIL_PTR, NIL_PTR, True, "")
#define error(str1, str2)		\
	(void) bottom_line (ON, (str1), (str2), NIL_PTR, False, "")
#define clear_status()			\
	(void) bottom_line (OFF, NIL_PTR, NIL_PTR, NIL_PTR, False, "")
#define get_string(str1, str2, fl, term_chars)	\
	bottom_line (ON, (str1), NIL_PTR, (str2), fl, term_chars)

/*
 * Print info about current file and buffer.
 */
#define fstatus(mess, bytes, chars)	\
	file_status ((mess), (bytes), file_name, total_lines, True, writable, modified, viewonly, (chars))

/*
 * Build formatted string.
 * If this definition is left out, a routine will be defined in mined1.c.
 */
#define build_string sprintf /**/

/*
 * Get real shift value.
 */
#define get_shift(cnt)		((cnt) & DUMMY_MASK)

/*
 * Special character.
 */
#define QUITCHAR '\034' /* ^\ */

/*------------------------------------------------------------------------*/
#endif
/*------------------------------------------------------------------------*/
